{$B-}
unit boxes;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TBoxForm = class(TForm)
    Label1: TLabel;
    OkBtn: TButton;
    CancelBtn: TButton;
    HelpBtn: TButton;
    procedure HelpBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    fHelpContext : integer;
    procedure CenterButtons;
  public
  end;

var
  BoxForm: TBoxForm;

// Hlp -  HelpContext  Application
procedure MessageBox(Capt : string; Hlp : integer);
procedure ErrorBox(Capt : string; Hlp : integer);
//  TRUE  FALSE     .
function  AskBox(Capt : string; Hlp : integer) : boolean;
//   Cond = FALSE,   
procedure CondMessageBox(Capt : string; Hlp : integer; Cond : boolean);
procedure CondErrorBox(Capt : string; Hlp : integer; Cond : boolean);
//   Cond = FALSE,   TRUE
function  CondAskBox(Capt : string; Hlp : integer; Cond : boolean) : boolean;

implementation

const
   gERRORBOX_CAPTION          = '!';
   gASKBOX_CAPTION            = '!';
   vk_Esc                     = 27;

{$R *.DFM}

procedure TBoxForm.CenterButtons;
var
   i,Center : integer;
begin
     i := 0;
     if OkBtn.Visible then Inc(i);
     if CancelBtn.Visible then Inc(i);
     if HelpBtn.Visible then Inc(i);
     Center := ClientWidth shr 1;
     case i of
       1 : OkBtn.Left := Center - OkBtn.Width shr 1;
       2 : begin
                OkBtn.Left := Center - OkBtn.Width - 5;
                HelpBtn.Left := Center + 5;
           end;
       3 : begin
                with OkBtn do Left := Center - Width - Width shr 1 - 10;
                with CancelBtn do Left := Center - Width shr 1;
                with HelpBtn do Left := Center + Width shr 1 + 10;
           end;
     end;
     OkBtn.SetFocus;
end;

procedure MessageBox;
begin
     with BoxForm do begin
        Caption := gASKBOX_CAPTION;
        Label1.Caption := Capt;
        fHelpContext := Hlp;
        CancelBtn.Visible := FALSE;
        HelpBtn.Visible := TRUE;
        ShowModal;
     end;
end;

procedure ErrorBox;
begin
     with BoxForm do begin
        Caption := gERRORBOX_CAPTION;
        Label1.Caption := Capt;
        fHelpContext := Hlp;
        CancelBtn.Visible := FALSE;
        HelpBtn.Visible := TRUE;
        ShowModal;
     end;
end;

function AskBox;
begin
     with BoxForm do begin
        Caption := gASKBOX_CAPTION;
        Label1.Caption := Capt;
        fHelpContext := Hlp;
        CancelBtn.Visible := TRUE;
        HelpBtn.Visible := TRUE;
        ShowModal;
        Result := ModalResult = mrOk;
     end;
end;

procedure CondMessageBox;
begin
     if Cond then MessageBox(Capt,Hlp);
end;

procedure CondErrorBox;
begin
     if Cond then ErrorBox(Capt,Hlp);
end;

function CondAskBox;
begin
     Result := not Cond or AskBox(Capt,Hlp);
end;

procedure TBoxForm.HelpBtnClick(Sender: TObject);
begin
     Application.HelpCommand(1,fHelpContext);
end;

procedure TBoxForm.FormActivate(Sender: TObject);
begin
     CenterButtons;
end;

procedure TBoxForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if Key = vk_F1 then HelpBtn.Click;
     if Key = vk_Esc then CancelBtn.Click;
end;

initialization

     BoxForm := TBoxForm.Create(BoxForm);

end.
